version: '3.3'


services:
  mysql:
    image: mysql:5.7
    container_name: ved_api_db
    volumes:
      - ./data:/var/lib/mysql
    expose:
      - "3306"
    environment:
      - MYSQL_ROOT_HOST=%
      - MYSQL_ROOT_PASSWORD=pass
      - MYSQL_DATABASE=test_users_db
    restart: always
    command: "mysqld --character-set-server=utf8mb4 --collation-server=utf8mb4_unicode_ci"
    networks:
      - backend


  api:
    build: ./
    container_name: ved_api_container
    restart: "no"
    volumes:
      - ./logs/:/code/logs
    ports:
      - "8080:8080"
    depends_on:
      - mysql
    environment:
      - SECRET_KEY_VED=$SECRET_KEY_VED
    networks:
      - backend


  locust_master:
    image: locustio/locust
    ports:
      - "8088:8088"
    volumes:
      - ./locust/:/mnt/locust
      - ./logs/:/logs
    environment:
      - CSV_STATS_FLUSH_INTERVAL_SEC=2
    command: "-f /mnt/locust/locustfile.py --master -H http://master:8089 --headless -u 1000 -r 100 --run-time 10s 
              --logfile /mnt/locust/locust_log.txt --host http://api:80 --csv /mnt/locust/csv"
    depends_on:
      - api
    networks:
      - backend

  locust_worker:
    image: locustio/locust
    volumes:
      - ./locust/:/mnt/locust
    command: -f /mnt/locust/locustfile.py --worker --master-host locust_master
    networks:
      - backend

networks:
  backend:
    driver: bridge
